Saturday, August 8, 2015

Leetcode 239: sliding window maximum//nearest smallest element

Given an array nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding window moves right by one position.

For example,
Given nums = [1,3,-1,-3,5,3,6,7], and k = 3.
Window position                Max
---------------               -----
[1  3  -1] -3  5  3  6  7       3
 1 [3  -1  -3] 5  3  6  7       3
 1  3 [-1  -3  5] 3  6  7       5
 1  3  -1 [-3  5  3] 6  7       5
 1  3  -1  -3 [5  3  6] 7       6
 1  3  -1  -3  5 [3  6  7]      7
Therefore, return the max sliding window as [3,3,5,5,6,7].

这个题目是每次移动一个size 为k的窗口,求这个窗口里的最大值。
我们可以维护一个deque为window,deque的front()为最大值,在size 为k的窗口形成之前,即窗口里的元素个数<k的时候,count = 1 -》 1, count = 2-》 3, 此时由于3>1,所以1不可能是后面的最大值了,所以可以把1去掉,然后, count = 3-》3, 但是此时-1<3,当窗口移动的时候,-1可能是下一个窗口的最大值,所以保留,当count = k的时候,这个时候可以将deque的front() push_back 到rst中,此后,每次移动一次,都要将deque的front()push_back到rst中。 那么对于前面的deque操作,怎么去实现呢? 对这个deque有三种操作, push_back, pop_front(), pop_back(),这三种操作分别对应的情况如下:
push_back:array里的元素肯定是不断地push_back到deque里面的, 但是在push_back之前需要先看deque里面的元素进行相应的pop_front(), pop_back(), 最后才能push_back();
pop_front(): pop_front() 发生在当窗口左边移动,在窗口外面的元素需要移出窗口, 即当current index - front()->index >= k, 需要pop_front();
pop_back(); pop_back()发生在当current element > back()->value的时候,需要将window里面比current element小的所有元素移出。
整个过程,根据需要先对pop_front(),pop_back()进行操作,最后再push_back新的元素,并且维护一个counter,如果counter =k, 则将deque的front()元素push_back到结果里面去。
这个题目其实是对每个元素,找nearest maximum,窗口里面维护的是一个递减的size<=k的数组,因为较小的elment可能是下一个窗口的最大值需要保留,而对于遇到一个新的较大的element,那么该窗口里面所有比这个element小的值是较旧的element,要pop出去,因为这些值是不可能成为下一个窗口最大值的。
class Solution {
public:
    vector<int> maxSlidingWindow(vector<int>& nums, int k) {
        vector<int> rst;
        //pair<int, int>: first-> index, second-> value
        //the front of deque is the max num of current position
        deque<pair<int, int>> maxq;
        int count = 0;
        for (int i = 0; i < nums.size(); i++) {
            //case 1: pop from back
            while (!maxq.empty() && nums[i] > maxq.back().second) {
                maxq.pop_back();
            }
            //case 2: pop from front
            if (!maxq.empty() && i - maxq.front().first >= k) {
                maxq.pop_front();
            }
            maxq.push_back(make_pair(i,nums[i]));
            if (count < k) count++;
            if (count == k) rst.push_back(maxq.front().second);
        }
        return rst;
    }
};

下面这个题目是跟上面那个sliding window maximum相似的题目:
Q4 Given an array A[N] of integers, for each index i, find the nearest j from index i, such that A[j] < A[i] and j < i,    print out  A[j]         ( 0 <= i < N ).
Example:
Input:  arr[] = {1, 6, 4, 10, 2, 5}
Output:          {_, 1, 1,  4, 1, 2}

这个题目和上面的sliding window maximum相似在于, 都是动态地要找到每一个element的nearest minimal/nearest maximum, 都可以动态去维护一个数据结构,并且对数据结构里面的元素进行操作。 这个题目很明显是要找到每一个element的nearest minimal, 最近最小值, 并且此处并没有要求window相关, 没有必要进行pop_front(), 对于linear回头看之前的元素,我们可以用一个stack来进行判断.  这个题目里面stack维护的元素是递增的。

stack 的操作有两个: pop(): 发生在如果current element < top(),那么说明当前窗口 里比current 大元素都不可能是nearest maximum了。
push(): 发生在pop之后,将current push进stack。

vector<int> Nearest(const vector<int> &input) {
    vector<int> rst;
    //sanity check
    if (input.size() == 0) return rst;
    stack<int> s;
    for (int i = 0; i < input.size(); i++) {
    while (!s.empty() && input[i] <= s.top()) {
    s.pop();
}
if (!s.empty()) rst.push_back(s.top());
s.push(nums[i]);
}
return rst;
}

No comments:

Post a Comment